package com.example.aped.communication;

import com.android.volley.Response;

import org.json.JSONObject;

import java.io.File;

public interface IIO
{
    /**
     * reads a value from a device connected to the raspberry
     * @param deviceName the name of the device to read from
     * @return the value read
     */
    void read(String deviceName, Response.Listener<JSONObject> responseListener);

    /**
     * writes a value to a device connected to the raspberry
     * @param deviceName the name of the device to write to
     * @param value the value to write to the device
     * @return the value written
     */
    void write(String deviceName, String value, Response.Listener<JSONObject> responseListener);

    /**
     * uploads the config.xml to the raspberry
     * @param xmlFile the config.xml
     * @return 0 if everything worked
     */
    void uploadXML(File xmlFile);

    /**
     * downloads the current config.xml from the raspberry
     * @return 0 if everything worked
     */
    void downloadXML();
}
